<form [formGroup]="form" (ngSubmit)="onSubmit(form.value)" enctype="multipart/form-data">

<div class="outer-container">
  <div class="input-container">
    <div class="form-input-container" >
      <mat-form-field class="input-block">
        <input matInput [(ngModel)]="selectedItem.itemId" maxLength="10" UpperCaseText placeholder="Id Barang" name="itemId" id="itemId" formControlName="itemId" >
        <button mat-button *ngIf="selectedItem.itemId" [disabled]="isEdit" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemId=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
          <p *ngIf="form.controls.itemId.errors?.required&&(form.controls.itemId.touched||submitted)" class="error-message">Id Barang tidak boleh kosong.</p>
      </div>
    </div>

    <div class="form-input-container">
      <mat-form-field class="input-block">
        <input matInput [(ngModel)]="selectedItem.itemName" placeholder="Nama Barang" name="itemName" id="itemName" formControlName="itemName">
        <button mat-button *ngIf="selectedItem.itemName" [disabled]="checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemName=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
        <div class="input-message-container">
            <p *ngIf="form.controls.itemName.errors?.required&&(form.controls.itemName.touched||submitted)" class="error-message">Nama Barang tidak boleh kosong.</p>
        </div>
    </div>

    <div class="form-input-container">
      <mat-form-field style="width:100%">
        <mat-select class="input-block" placeholder="Kategori Barang" [(ngModel)]="selectedItem.itemCategory.categoryId" name="itemCategoryId" id="itemCategoryId" formControlName="itemCategoryId">
          <mat-option *ngFor="let category of categories" [value]="category.categoryId">
            {{ category.categoryName }}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class="input-message-container select-message">
        <p *ngIf="form.controls.itemCategoryId.errors?.required&&(form.controls.itemCategoryId.touched||submitted)" class="error-message">Kategori Barang tidak boleh kosong.</p>
      </div>
    </div>

    <div class="form-input-container">
      <mat-form-field class="input-block">
        <input [(ngModel)]="selectedItem.itemBuyDate" matInput type="date" placeholder="Tanggal Beli" name="itemBuyDate" id="itemBuyDate" formControlName="itemBuyDate">
      </mat-form-field>
      <div class="input-message-container">
        <p *ngIf="form.controls.itemBuyDate.errors?.required&&(form.controls.itemBuyDate.touched||submitted)" class="error-message">Tanggal Beli tidak boleh kosong.</p>
        <p *ngIf="form.controls.itemBuyDate.errors?.validateDate&&(form.controls.itemBuyDate.touched||submitted)" class="error-message">Masukkan tanggal dengan format yang benar</p>
      </div>
    </div>

    <div class="form-input-container" >
      <mat-form-field class="input-block">
        <textarea matInput [(ngModel)]="selectedItem.itemNote" matTextareaAutosize matAutosizeMinRows="2" matAutosizeMaxRows="5" 
              placeholder="Catatan Barang" name="itemNote" id="itemNote" formControlName="itemNote"></textarea>
        <button mat-button *ngIf="selectedItem.itemNote" [disabled]="checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemBuyDate=''">
          <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
      </div>
    </div>
  </div>

  <div class="input-container">
    <div class="form-input-container">
      <mat-form-field class="input-block">
        <input matInput maxLength="10" [(ngModel)]="selectedItem.itemWeight" OnlyNumber="true" placeholder="Berat Barang (Gram)" name="itemWeight" id="itemWeight" formControlName="itemWeight">
        <button mat-button *ngIf="selectedItem.itemWeight" [disabled]="checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemWeight=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
        <p *ngIf="form.controls.itemWeight.errors?.required&&(form.controls.itemWeight.touched||submitted)" class="error-message">Berat Barang tidak boleh kosong.</p>
      </div>
    </div>

    <div class="form-input-container">
      <mat-form-field class="input-block">
        <input matInput maxLength="6" [(ngModel)]="selectedItem.itemGoldContent" OnlyNumber="true" placeholder="Kadar Emas (%)" name="itemGoldContent" id="itemGoldContent" formControlName="itemGoldContent">
        <button mat-button *ngIf="selectedItem.itemGoldContent" [disabled]="checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemGoldContent=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
        <p *ngIf="form.controls.itemGoldContent.errors?.required&&(form.controls.itemGoldContent.touched||submitted)" class="error-message">Kadar Emas tidak boleh kosong</p>
      </div>
    </div>

    <div class="form-input-container">
      <mat-form-field class="input-block">
        <input matInput CurrencyFormatter maxLength="15" [(ngModel)]="selectedItem.itemBuyPrice" OnlyNumber="true"  placeholder="Harga Beli (IDR)" name="itemBuyPrice" id="itemBuyPrice" formControlName="itemBuyPrice">
        <button mat-button *ngIf="selectedItem.itemBuyPrice" [disabled]="checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemBuyPrice=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
        <p *ngIf="form.controls.itemBuyPrice.errors?.required&&(form.controls.itemBuyPrice.touched||submitted)" class="error-message">Harga Beli tidak boleh kosong</p>
      </div>
    </div>

    <div class="form-input-container">
      <mat-checkbox [disabled]="checkFormDisabled()" [(ngModel)]="checkedEntrusted" (change)="changeDisabled()" [ngModelOptions]="{standalone: true}">Barang Orang</mat-checkbox>
      <mat-form-field class="input-block">
        <input matInput [(ngModel)]="selectedItem.itemEntrustedStatus" placeholder="Barang Orang" name="itemEntrustedStatus" id="itemEntrustedStatus" formControlName="itemEntrustedStatus">
        <button mat-button *ngIf="selectedItem.itemEntrustedStatus" [disabled]="!checkedEntrusted||checkFormDisabled()" matSuffix mat-icon-button aria-label="Clear" (click)="selectedItem.itemEntrustedStatus=''">
            <mat-icon>close</mat-icon>
        </button>
      </mat-form-field>
      <div class="input-message-container">
        <p *ngIf="form.controls.itemEntrustedStatus.errors?.required&&(form.controls.itemEntrustedStatus.touched||submitted)" class="error-message">Barang orang tidak boleh kosong jika sudah dicentang</p>
      </div>
    </div>

    <label id="trigger-photo-upload" for="itemPhoto" hidden></label>
    <input type="file" hidden name="itemPhoto" id="itemPhoto" (change)="setFile($event)" accept="image/jpeg, image/png" formControlName="itemPhoto">
  </div>

  <div class="input-container picture-input-container desktop-tablet">
    <img class="item-picture" [src]="itemPicture" width="100%" (click)="triggerUploadWindow()">
    <p *ngIf="forbiddenFile" class="error-message">Gunakan gambar dengan format JPG/PNG dan ukuran file kurang dari 1Mb</p>
    <img *ngIf="selectedItem.itemTransaction" matTooltip="Barang terjual, Klik untuk lihat detail" [src]="getSoldIcon()" width="100%" (click)="openSoldDetailDialog(selectedItem)">
  </div>
</div>

  <div class="input-container submit-button-container">
    <a (click)="sendCancel()" color="light" mat-raised-button>Batal</a>
    <button *ngIf="!checkFormDisabled()" type="submit" color="accent" mat-raised-button>Simpan</button>
    <a *ngIf="!selectedItem.itemTransaction&&itemId" (click)="openSoldItemDialog(selectedItem)" color="accent" mat-raised-button>Terjual</a>
  </div>
</form>
